# -*- coding: utf-8 -*-
# Dengxin's image crawler, using Bing Image Search Engine
# dai@vision.ee.ethz.ch
# bing_crawler.py -q <query> -n <img_num> -o <offset> -s <save_path>
import urllib
import urllib2
from urllib import FancyURLopener
import json
import time
import getopt, sys


def main(argv):
 
    query = argv[0]
    img_num = int(argv[1])
    offset  = int(argv[2])
    save_path = argv[3]

    top_n = 50        #default value of the top of Bing Engine

    #account key: https://datamarket.azure.com/account/keys
    key= argv[4] #'0G9aiiLsJGkBlKpwd0Et37Vq63DtB3xAz6jWiz7mo2s='

    # iterate with different offset to get different sets of images
    img_n_l = img_num
    while img_n_l > top_n:

        bing_search(query, top_n, offset, key, save_path)
        offset  += top_n
        img_n_l -= top_n
        pass
    else:
        bing_search(query, img_n_l, offset, key, save_path)

 
        
def bing_search(query, img_num, offset, key, save_path):

    #query = urllib.quote(query)
    # create credential for authentication
    user_agent = 'Mozilla/5.0 (X11; U; Linux i686) Gecko/20071127 Firefox/2.0.0.11'
    credentials = (':%s' % key).encode('base64')[:-1]
    auth = 'Basic %s' % credentials
    url = 'https://api.datamarket.azure.com/Data.ashx/Bing/Search/Image'+'?Query=%27'+query+'%27&$top=' \
          +str(img_num)+'&$skip='+str(offset)+'&$format=json'

    request = urllib2.Request(url)
    request.add_header('Authorization', auth)
    request.add_header('User-Agent', user_agent)
    request_opener = urllib2.build_opener()
    response = request_opener.open(request) 
    response_data = response.read()
    json_result = json.loads(response_data)
    result_list = json_result['d']['results']


    class MyOpener(FancyURLopener): 
        version = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; it; rv:1.8.1.11) Gecko/20071127     Firefox/2.0.0.11'
    myopener = MyOpener()

    # Iterate for each result and get unescaped url
    count = offset
    for myUrl in result_list:
        count = count + 1
        print count

        try:
            myopener.retrieve(myUrl['MediaUrl'], save_path + '//' + str(count)+ '.jpg')
        except IOError:
            print 'connection failed *****'
            continue
       # print myUrl['MediaUrl']
        time.sleep(0.5)


   
 
if __name__ == "__main__":
    main(sys.argv[1:])

